#include "vxBoot/terminal.h"
#include "vxBoot/fs/smemfs.h"
#include "vxBoot/loader.h"
#include "vxBoot/gui.h"
#include "vxBoot/cli.h"

#include <gint/display.h>


/* entry of the bootloader */
int main(void)
{
	/* change default font on fx9860 */
#ifdef FX9860G
	extern font_t font_hexa;
	dfont(&font_hexa);
#endif
#ifdef FXCG50
	extern font_t font_fxcg50;
	dfont(&font_fxcg50);
#endif

	/* early log */
	terminal_open();
	terminal_write(
		"Welcome to vxBoot, the bootstrapper for the Vhex kernel!\n"
		"Type `help` for instruction on how to use vxBoot\n"
	);

	/* automated hook */
	/* TODO: better way to execute early command */
	smemfs_mount();
	loader_scan();

	/* GUI Loop */
	if (loader_kernel_img_count() >= 1)
		gui_main();
	cli_main();
	return (1);
}
